/* -*- C -*- */
/* Time-stamp: "2006-06-01 14:46:38 fujiwara" */

/**********************************************************************/
/*  Copyright (C) 1999, Fujiwara Hiroshi                              */
/*        <fujiwara@acs.i.kyoto-u.ac.jp>                              */
/**********************************************************************/

static char rcsid[] = "$Id: const.c,v 1.1.1.1 2002/04/07 07:18:09 fujiwara Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "exfloat.h"

/**********************************************************************/
/* load constant value (convert a constant to a exfloat)              */
/* s has no '#' character.                                            */
/**********************************************************************/

void exflib_float_ctoef(const char *s, exflib_uQword u[], long pr64)
{
    exflib_cuQword *c;
    
    long i;
    
    static exflib_cuQword pi[] = {
#include "pi.exfloat"
    };

    static exflib_cuQword e[] = {
#include "e.exfloat"
    };

    static exflib_cuQword ln10[] = {
#include "ln10.exfloat"
    };

    static exflib_cuQword ln2[] = {
#include "ln2.exfloat"
    };

    static exflib_cuQword atan_h[] = {
#include "atan_h.exfloat"
    };

    static exflib_cuQword atan_q[] = {
#include "atan_q.exfloat"
    };

    static exflib_cuQword gamma[] = {
#include "gamma.exfloat"
    };

    if(!strcmp(s, "PI") || !strcmp(s, "pi")){

	c = pi;

    } else if(!strcmp(s, "E") || !strcmp(s, "e")
	      || !strcmp(s, "NAPIER") || !strcmp(s, "napier")){

	c = e;

    } else if(!strcmp(s, "LN10") || !strcmp(s, "ln10")){

	c = ln10;

    } else if(!strcmp(s, "LN2") || !strcmp(s, "ln2")){

	c = ln2;

    } else if(!strcmp(s, "atan_h")){

	c = atan_h;

    } else if(!strcmp(s, "atan_q")){

	c = atan_q;

    } else if(!strcmp(s, "G") || !strcmp(s, "g")) {

	c = gamma;

    } else {

	fprintf(stderr, "Unkown constant: #%s\n", s);
	exit(1);
    }
    
    for(i = 0; i <= pr64; i++)
	u[i] = c[i];
    
    return;
}

/* End of const.c */
