/* -*- C -*- */
/* Time-stamp: "2006-04-17 10:38:16 fujiwara" */

/**********************************************************************/
/*  Copyright (C) 2006, FUJIWARA Hiroshi                              */
/*        <fujiwara@acs.i.kyoto-u.ac.jp>                              */
/**********************************************************************/

static char rcsid[] = "$Id: $";

#include "exfloat.h"
#include <stdio.h>

/*----------------------------------------------------------------------*/
/* expression to exfloat number                                         */
/*----------------------------------------------------------------------*/

void exflib_float_etoef_f77_(exflib_uQword u[], const char *s, long *pr64)
{
    exflib_float_etoef(s, u, *pr64);
    return;
}

void exflib_float_etoef_f77__(exflib_uQword u[], const char *s, long *pr64)
{
    exflib_float_etoef(s, u, *pr64);
    return;
}

void exflib_float_etoef_f90_(exflib_uQword **u, const char *s, long *pr64)
{
    exflib_float_etoef(s, *u, *pr64);
    return;
}

void exflib_float_etoef_f90__(exflib_uQword **u, const char *s, long *pr64)
{
    exflib_float_etoef(s, *u, *pr64);
    return;
}

/*----------------------------------------------------------------------*/
/* loading exfloat type constant                                        */
/*----------------------------------------------------------------------*/

void exflib_float_ctoef_f77_(exflib_uQword u[], const char *s, long *pr64)
{
    exflib_float_ctoef(s, u, *pr64);
    return;
}

void exflib_float_ctoef_f77__(exflib_uQword u[], const char *s, long *pr64)
{
    exflib_float_ctoef(s, u, *pr64);
    return;
}

void exflib_float_ctoef_f90_(exflib_uQword **u, const char *s, long *pr64)
{
    exflib_float_ctoef(s, *u, *pr64);
    return;
}

void exflib_float_ctoef_f90__(exflib_uQword **u, const char *s, long *pr64)
{
    exflib_float_ctoef(s, *u, *pr64);
    return;
}

/*----------------------------------------------------------------------*/
/* exfloat number to double                                             */
/*----------------------------------------------------------------------*/

double exflib_float_eftod_f77_(exflib_cuQword *u)
{
    return exflib_float_eftod(u);
}

double exflib_float_eftod_f77__(exflib_cuQword *u)
{
    return exflib_float_eftod(u);
}

double exflib_float_eftod_f90_(exflib_cuQword **u)
{
    return exflib_float_eftod(*u);
}

double exflib_float_eftod_f90__(exflib_cuQword **u)
{
    return exflib_float_eftod(*u);
}

#if 0
double exflib_double_(exflib_cuQword u[]){ return exflib_float_eftod(u); }
double exflib_double__(exflib_cuQword u[]){ return exflib_float_eftod(u); }
#endif

/*----------------------------------------------------------------------*/
/* double to exfloat number                                             */
/*----------------------------------------------------------------------*/

void exflib_float_dtoef_f77_(exflib_uQword u[], const double *d, long *pr64)
{
    exflib_float_dtoef(*d, u, *pr64);
    return;
}
void exflib_float_dtoef_f77__(exflib_uQword u[], const double *d, long *pr64)
{
    exflib_float_dtoef(*d, u, *pr64);
    return;
}

void exflib_float_dtoef_f90_(exflib_uQword **u, const double *d, long *pr64)
{
    exflib_float_dtoef(*d, *u, *pr64);
    return;
}

void exflib_float_dtoef_f90__(exflib_uQword **u, const double *d, long *pr64)
{
    exflib_float_dtoef(*d, *u, *pr64);
    return;
}

/*--------------------------------------------------------------------*/
/* convert C string to FORTRAN string                                 */
/*--------------------------------------------------------------------*/

#define FORTRAN_PADDING_CHAR ' '

void exflib_trim_c_null(char *str){
    int i;
    for(i = 0; str[i] != '\0'; i++)
      continue;
    str[i] = FORTRAN_PADDING_CHAR;
    return;
}

/* End of file */
