/* -*- C -*- */
/* $Id:$ */
/* Time-stamp: "2005-02-02 18:51:16 fujiwara" */

/***********************************************************************/
/* Routines Used in Built-in Functions                                 */
/***********************************************************************/

#ifndef FUNC_H
#define FUNC_H

/* number of terms required in Taylor expansion */

long exflib_taylor_tranc_sin(long arrays, long e);
long exflib_taylor_tranc_cos(long arrays, long e);
long exflib_taylor_tranc_exp(long arrays, long e);
long exflib_taylor_tranc_log(long arrays, long e);
long exflib_taylor_tranc_atan(long arrays, long e);


/* utility routine in func_common.h */
void exflib_array_2s_complement(exflib_cuQword a[], exflib_uQword b[], long size);
void exflib_exfloat_to_array(exflib_cuQword floatp[], long e, exflib_uQword fixedp[], long size);
void exflib_array_to_exfloat(exflib_uQword v[], long pr64);
void exflib_sll_onebit(exflib_uQword v[], long size);

/* additive reduction used in Taylor expansion of sin,cos,exp */
long exflib_add_reduction(exflib_cuQword x[], long cc, exflib_uQword r[], exflib_ulong pr64, exflib_Qword *k);
/* long exflib_modf(exflib_cuQword x[], exflib_uQword ip[], exflib_Qword *k, long pr64); */
    

void exflib_array_sin(exflib_uQword x[], exflib_uQword v[], long pr64);
void exflib_array_cos(exflib_uQword x[], exflib_uQword v[], long pr64);

void exflib_invadd(exflib_uQword x[], long n, exflib_uQword table[], long sign, 
long size);

#endif

/* End of func.h */
