/* -*- C -*- */
/* Time-stamp: "2006-03-17 00:36:50 fujiwara" */

/**********************************************************************/
/*  fmod, floating-pointy remainder, r, same sign as d                */
/*                                                                    */
/*    The last argument mem[] is the working memory,                  */
/*    with (1+pr64) elements                                          */
/*                                                                    */
/*  Copyright (C) 2006, FUJIWARA Hiroshi                              */
/*        <fujiwara@acs.i.kyoto-u.ac.jp>                              */
/**********************************************************************/

static char rcsid[] = "$Id: $";
#include "exfloat.h"
#include <stdio.h>
#include <stdlib.h> /* exit() */

void exflib_float_fmod(exflib_uQword r[],
		       exflib_cuQword d[], exflib_cuQword m[], long pr64,
		       exflib_uQword mem[])
{
    /* zero check */
    if((d[0] & (~EXFLIB_MASK_SGN)) == 0){
	fprintf(stderr, "fmod: domain error\n");
	exit(1);
    }

    exflib_float_div(r, d, m, pr64);
    exflib_float_modf(r, mem, r, pr64);
    exflib_float_mul(r, m, mem, pr64);
    exflib_float_sub(r, d, r, pr64);
    return;
}

/* End of file */
