/* -*- C -*- */
/* Time-stamp: "2005-01-15 15:42:54 fujiwara" */

/**********************************************************************/
/*  Copyright (C) 1999, Fujiwara Hiroshi                              */
/*        <fujiwara@acs.i.kyoto-u.ac.jp>                              */
/**********************************************************************/

static char rcsid[] = "$Id: hex.c,v 1.1.1.1 2002/04/07 07:18:09 fujiwara Exp $";

#include <stdio.h>
#include <stdlib.h>

#include "exfloat.h"

/**********************************************************************/
/* set exfloat by hexadecimal format (convert a hex to a exfloat)     */
/* s has no '@' character.                                            */
/**********************************************************************/

void exflib_float_htoef(const char *s, exflib_uQword u[], long pr64)
{
    long i;
    exflib_uQword _u;

    for(i = 0; (i <= pr64) && *s; i++){

	for(_u = 0; (*s != ':') && *s; s++){

	    _u <<= 4;
	    
	    if(('A' <= *s) && (*s <= 'F')){

		_u += 10 + *s - 'A';
		
	    } else if(('a' <= *s) && (*s <= 'f')){

		_u += 10 + *s - 'a';
		
	    } else if(('0' <= *s) && (*s <= '9')){

		_u += *s - '0';

	    } else {

		fprintf(stderr, "Unexpected character: %c\n", *s);
		exit(1);
	    }
	}

	if(*s == ':')
	    s++;
	
	u[i] = _u;
    }
    for(; i <= pr64; i++)
	u[i] = 0;

    return;
}

/* End of hex.c */
