#
#  Classifing CPU, OS types
#
#  Time-stamp: "2005-03-01 20:26:16 fujiwara"
#

#----------------------------------------------------------------------
#  System Type
#
#  i386-(linux|freebsd|mingw|cygwin)
#  i86pc-solaris
#  x86_64-linux
#
#  ppc32-darwin
#  alpha-(linux|OSF1)
#  ia64
#  sun4u-solaris
#
OS := $(shell uname -s | \
	sed -e s/.*Linux.*/linux/ -e s/.*FreeBSD.*/freebsd/ \
	-e s/.*MINGW32.*/mingw/ -e s/.*CYGWIN.*/cygwin/ \
	-e s/SunOS/solaris/ -e s/Darwin/darwin/ )

ARCH := $(shell \
	if [ $(OS) = "solaris" ] ; then \
	isainfo | cut -d' ' -f1 | sed -e s/amd64/x64/ -e s/i386/i86pc/ ; \
	else \
	uname -m | \
	sed -e s/i.86/i386/ \
	-e s/Power.Macintosh/ppc/ \
	-e s/ia64/other/ -e s/alpha/other/ ; fi )

#----------------------------------------------------------------------
#
# We require GNU make for building the package.
#
#   Linux        : make is GNU make,       gmake is available
#   FreeBSD      : make is NOT GNU make,   we use /usr/local/bin/gmake
#   Darwin       : make is GNU make,       gmake is not available
#   Cygwin/MinGW : make is GNU make,       gmake is not available
#
GMAKE := $(shell \
	if [ $(OS) = "mingw" -o $(OS) = "cygwin" -o $(OS) = "darwin" ] ; then \
	echo "make"; \
	else echo "gmake" ; fi )

#----------------------------------------------------------------------
#
# We require GNU cp (cp -l option) for building the package.
#
# Linux, Darwin, Cygwin, MinGW : /bin/cp is GNU cp
# FreeBSD : /bin/cp is NOT GNU cp, we use /usr/local/bin/cp
#
CP := $(shell \
	if [ -f "/usr/local/bin/cp" ] ; then echo "/usr/local/bin/cp"; \
	else echo "cp" ; fi )


#----------------------------------------------------------------------

TARGET=exflib-$(ARCH)-$(OS)

#
# End of config.mak
#
